#ifndef _TS_Bus_H
#define _TS_Bus_H

#include "Prefix.h"
#include "EARTH_PT.h"
#include "TS_Device.h"
#include "TS_Utility.h"

namespace EARTH {
namespace TS {
	class Bus {
	public:
		Bus()
		{
			mBus = NULL;
		}

		~Bus()
		{
			if (mBus) {
				status status = mBus->Delete();
				if (Error(L"Bus::Delete()", status)) return;
				mBus = NULL;
			}
		}

		void Run(PT::Bus::NewBusFunction function)
		{
			_ASSERTE(mBus == NULL);
			status status = function(&mBus);
			if (Error(L"Bus::Run()", status)) return;
			_ASSERTE(mBus);

			uint version;
			mBus->GetVersion(&version);
			if ((version >> 8) != 1) {
				::wprintf(L"CXg[Ă SDK ̃o[W(0x%08x) ɂ͑ΉĂ܂B\n", version);
				return;
			}

			PT::Bus::DeviceInfo deviceInfo[9];	// ̃Tvł GetNumber() ŃfoCXI΂ȂƂȂ߁A
												// foCX̏ 9 ɂĂ܂B
			uint deviceInfoCount = sizeof(deviceInfo)/sizeof(*deviceInfo);
			mBus->Scan(deviceInfo, &deviceInfoCount, 3);

			bool done = false;
			while (done == false) {
				::wprintf(L"[foCXIj[]\n");
				::wprintf(L"   Bus Dev Fun Cnt\n");
				for (uint i=0; i<deviceInfoCount; i++) {
					const PT::Bus::DeviceInfo *info = &deviceInfo[i];
					::wprintf(L"%d: %3d %3d %3d %3d\n",
						i, info->Bus, info->Slot, info->Function, info->BadBitCount);
				}

				::wprintf(L"%d: I\n", deviceInfoCount);
				::wprintf(L">");
				uint number = GetNumber(deviceInfoCount);
				if (number == deviceInfoCount) {
					done = true;
				} else {
					const PT::Bus::DeviceInfo *info = &deviceInfo[number];
					if (info->BadBitCount) {
						::wprintf(L"BadBitCount  0 łȂfoCXIԂƂ͂ł܂B\n");
					} else {
						TS::Device *tsDevice = new TS::Device();
						tsDevice->Run(mBus, &deviceInfo[number]);
						delete_(tsDevice);
					}
				}
			}
		}

	protected:
		PT::Bus *mBus;
	};
}
}

#endif
